# Ziffern und Zahlen (Aufgabe 7.7 und 7.8)
# Gerhard Bitsch, August 2008

@tools=tools
@kara=kara
@world=world

# Die Methoden zur Darstellung der Ziffern erwarten die Koordinaten
# des linken unteren Ecks eines 6x8 Rechtecks

def hilf(x,y)
  2.upto(3) do |i|
    @world.setLeaf(x+i,y,true)
    @world.setLeaf(x+i,y-4,true)
    @world.setLeaf(x+i,y-7,true)
  end
end

def eins(x,y)
  2.upto(4) {|i| @world.setLeaf(x+i,y,true)}
  1.upto(7) {|i| @world.setLeaf(x+3,y-i,true)}
  1.upto(2) {|i| @world.setLeaf(x+i,y-4-i,true)}
end

def zwei(x,y)
  1.upto(4) do |i| 
    @world.setLeaf(x+i,y,true)
    @world.setLeaf(x+i,y-i,true)
  end
  5.upto(6) do |i|
    @world.setLeaf(x+1,y-i,true)
    @world.setLeaf(x+4,y-i,true)
  end
  2.upto(3) {|i| @world.setLeaf(x+i,y-7,true)}
end

def drei(x,y)
  1.upto(6) do |i|
    if i==4 then
      @world.setLeaf(x+3,y-i,true) 
    else
      @world.setLeaf(x+4,y-i,true)
    end
  end
  2.upto(3) do |i|
    @world.setLeaf(x+i,y,true)
    @world.setLeaf(x+i,y-7,true)
  end
  @world.setLeaf(x+1,y-6,true)
  @world.setLeaf(x+1,y-1,true)
end

def vier(x,y)
  3.upto(7) {|i| @world.setLeaf(x+1,y-i,true)}
  0.upto(5) {|i| @world.setLeaf(x+3,y-i,true)}
  2.upto(4) do |i|
    @world.setLeaf(x+i,y,true)
    @world.setLeaf(x+i,y-3,true)
  end
end

def fnf(x,y)
  hilf(x,y)
  4.upto(7) {|i| @world.setLeaf(x+1,y-i,true)}
  @world.setLeaf(x+1,y-1,true)
  @world.setLeaf(x+4,y-7,true)
  1.upto(3) {|i| @world.setLeaf(x+4,y-i,true)}
end

def sechs(x,y)
  hilf(x,y)
  1.upto(6) {|i| @world.setLeaf(x+1,y-i,true)}
  1.upto(3) {|i| @world.setLeaf(x+4,y-i,true)}
  @world.setLeaf(x+4,y-6,true)
end

def sieben(x,y)
  1.upto(3) do |i|
    @world.setLeaf(x+i,y-7,true)
    @world.setLeaf(x+i+1,y,true)
  end
  0.upto(3) do |i|
    @world.setLeaf(x+3,y-i,true)
    @world.setLeaf(x+4,y-4-i,true)
  end
end

def acht(x,y)
  hilf(x,y)
  1.upto(3) do |i|
    @world.setLeaf(x+1,y-i,true)
    @world.setLeaf(x+4,y-i,true)
  end
  5.upto(6) do |i|
    @world.setLeaf(x+1,y-i,true)
    @world.setLeaf(x+4,y-i,true)
  end
end
  
def neun(x,y)
  hilf(x,y)
  @world.setLeaf(x+1,y-1,true)
  @world.setLeaf(x+1,y-5,true)
  @world.setLeaf(x+1,y-6,true)
  1.upto(6) {|i| @world.setLeaf(x+4,y-i,true)}
end

def zero(x,y)
  2.upto(3) do |i|
    @world.setLeaf(x+i,y,true)
    @world.setLeaf(x+i,y-7,true)
  end
  1.upto(6) do |i|
    @world.setLeaf(x+1,y-i,true)
    @world.setLeaf(x+4,y-i,true)
  end
end

def schreibe(zif,x,y)
  case zif
    when 0: zero(x,y)
    when 1: eins(x,y)
    when 2: zwei(x,y)
    when 3: drei(x,y)
    when 4: vier(x,y)
    when 5: fnf(x,y)
    when 6: sechs(x,y)
    when 7: sieben(x,y)
    when 8: acht(x,y)
    when 9: neun(x,y)
  end
end

world.clearAll;
world.setSize(60,12);
0.upto(9) {|i| schreibe(i,i*6,10)}
tools.sleep(1500)

zahl=tools.intInput("Geben Sie eine natrliche Zahl ein!")
while zahl>-1 
  world.clearAll
  if zahl==0 then
    schreibe(zahl,54,10)
  else
    54.step(0,-6) do |x|
      break if zahl==0
      schreibe(zahl%10,x,10)
      zahl=zahl/10
    end
  end
  tools.sleep(1500)
  zahl=tools.intInput("Geben Sie eine natrliche Zahl ein!")
end
  